<?php
/*
Plugin Name: jQuery UI Slider
Plugin URI: http://www.christianschenk.org/projects/wordpress-jquery-ui-slider-plugin/
Description: jQuery UI Slider
Version: 1.1
Author: Christian Schenk
Author URI: http://www.christianschenk.org/
*/

#
# jQuery UI Slider
# Copyright (C) 2010 Christian Schenk
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
#

/**
 * Adds a link to the CSS stylesheet in the header.
 */
function jquis_add_css() { ?>
<style type="text/css">
#featured{ 
	width:400px; 
	padding-top:0;
	padding-bottom:0;
	padding-right:250px; 
	position:relative; 
	border:5px solid #ccc; 
	height:250px; 
	background:#fff;
}
#featured ul.ui-tabs-nav{ 
	position:absolute; 
	top:0; left:400px; 
	list-style:none; 
	padding:0; margin:0; 
	width:250px; 
}
#featured ul.ui-tabs-nav li{ 
	padding:1px 0; padding-left:13px;  
	font-size:12px; 
	color:#666; 
}
#featured ul.ui-tabs-nav li img{ 
	float:left; margin:2px 5px; 
	background:#fff; 
	padding:2px; 
	border:1px solid #eee;
}
#featured ul.ui-tabs-nav li span{ 
	font-size:11px; font-family:Verdana; 
	line-height:18px; 
}
#featured li.ui-tabs-nav-item a{ 
	display:block; 
	height:60px; 
	color:#333;  background:#fff; 
	line-height:20px;
}
#featured li.ui-tabs-nav-item a:hover{ 
	background:#f2f2f2; 
}
#featured li.ui-tabs-selected{ 
	background:url('<?php echo WP_PLUGIN_URL; ?>/jqueryuislider/images/selected-item.gif') top left no-repeat;  
}
#featured ul.ui-tabs-nav li.ui-tabs-selected a{ 
	background:#ccc; 
}
#featured .ui-tabs-panel{ 
	width:400px; height:250px; 
	background:#999; position:relative;
}
#featured .ui-tabs-panel .info{ 
	position:absolute; 
	top:180px; left:0; 
	height:70px; 
	background: url('<?php echo WP_PLUGIN_URL; ?>/jqueryuislider/images/transparent-bg.png'); 
	width:400px;
}
#featured .info h2{ 
	font-size:18px; font-family:Georgia, serif; 
	color:#fff; padding:0 0 0 5px; margin:0;
	overflow:hidden; 
}
#featured .info p{ 
	margin:0 5px; 
	font-family:Verdana; font-size:11px; 
	line-height:15px; color:#f0f0f0;
}
#featured .info a{ 
	text-decoration:none; 
	color:#fff; 
}
#featured .info a:hover{ 
	text-decoration:underline; 
}
#featured .ui-tabs-hide{ 
	display:none; 
}
</style>
<?php
}
if (function_exists('add_action'))
	add_action('wp_head', 'jquis_add_css');


/**
 * This will add the JavaScript to the footer.
 */
function jquis_add_js() { ?>
<script type="text/javascript" src="<?php echo WP_PLUGIN_URL; ?>/jqueryuislider/scripts/jquery.min.js" ></script>  
<script type="text/javascript" src="<?php echo WP_PLUGIN_URL; ?>/jqueryuislider/scripts/jquery-ui.min.js" ></script>  
<script type="text/javascript">
	$(document).ready(function(){
		$("#featured > ul").tabs({fx:{opacity: "toggle"}}).tabs("rotate", 5000, true);
	});
</script>
<?php
}
if (function_exists('add_action'))
	add_action('wp_footer', 'jquis_add_js');


/**
 * Supplies the user with a shortcode.
 */
function jquis_shortcode($atts) {
	extract(shortcode_atts(array('ds' => NULL), $atts));

	$data = null;
	if ($ds == 'wpec') {
		$data = jquis_get_wpec_products();
	} else {
		$data = jquis_get_posts();
	}

	return jquis_generate_markup($data);
}
if (function_exists('add_shortcode'))
	add_shortcode('slider', 'jquis_shortcode');


/**
 * Returns the four most recent posts.
 */
function jquis_get_posts() {
	global $wpdb;
	$posts = $wpdb->get_results('SELECT ID, post_title AS title, post_excerpt AS excerpt FROM '.$wpdb->posts.' WHERE post_type = "post" AND post_status = "publish" ORDER BY post_date DESC LIMIT 4');

	$items = array();
	foreach ($posts as $post) {
		$item = array();
		$item['title'] = get_the_title($post->ID);
		$item['url'] = get_permalink($post->ID);
		$item['desc'] = $post->excerpt;
		$item['image'] = get_post_meta($post->ID, 'Thumbnail', true);
		$item['thumb'] = get_post_meta($post->ID, 'Thumbnail1', true);
		$items[] = $item;
	}

	return $items;
}


/**
 * Returns WP e-Commerce's products.
 */
if (function_exists('wpsc_have_products')) {
	function jquis_get_wpec_products() {
		global $wpdb;
	
		$items = array();
		$curItem = 1;
		while (wpsc_have_products()) :  wpsc_the_product();
			$item = array();
			$item['title'] = wpsc_the_product_title();
			$item['url'] = wpsc_the_product_permalink();
			$item['desc'] = current(explode('\n', wordwrap(wpsc_the_product_description(), 120, '\n')));
			$item['image'] = wpsc_the_product_image(400, 250);
			$item['thumb'] = wpsc_the_product_image(80, 50);
			$items[] = $item;
			if ($curItem++ >= 4) break;
		endwhile;
	
		return $items;
	}
} else {
	function jquis_get_wpec_products() {
		return array();
	}
}


/**
 * Expects the following datastructure:
 * items
 *  - item 1
 *     - title
 *     - url
 *     - desc
 *     - image
 *     - thumb
 *  - item 2
 *    - ...
 */
function jquis_generate_markup($items) {
	if (empty($items) or !is_array($items))
		return;

	ob_start();
?>
<div id="featured" >
	<ul class="ui-tabs-nav">
		<?php $i = 1; foreach ($items as $item) : ?>
				<li class="ui-tabs-nav-item<?php if ($i == 1) echo ' ui-tabs-selected'; ?>" id="nav-fragment-<?php echo $i; ?>">
					<a href="#fragment-<?php echo $i; ?>"><img src="<?php echo $item['thumb']; ?>" alt="<?php echo $item['title']; ?>" /><span><?php echo $item['title']; ?></span></a>
				</li>
		<?php $i++; endforeach; ?>
	</ul>

	<?php $i = 1; foreach ($items as $item) : ?>
	    <div id="fragment-<?php echo $i; ?>" class="ui-tabs-panel<?php if ($i != 1) echo ' ui-tabs-hide'; ?>" style="">
			<img src="<?php echo $item['image']; ?>" alt="<?php echo $item['title']; ?>" />
			 <div class="info" >
				<h2><a href="<?php echo $item['url']; ?>" ><?php echo $item['title']; ?></a></h2>
				<p><?php echo $item['desc']; ?> <a href="<?php echo $item['url']; ?>" >read more</a></p>
			 </div>
	    </div>
	<?php $i++; endforeach; ?>

</div>
<?php
	$content = ob_get_contents();
	ob_end_clean();
	return $content;
}

?>
